//-----------------------------------------------------------------------------
// system_stub.v
//-----------------------------------------------------------------------------

module system_stub
  (
    fpga_0_RS232_Uart_1_sin_pin,
    fpga_0_RS232_Uart_1_sout_pin,
    fpga_0_LEDs_8Bit_GPIO_IO_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_ODT_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_Addr_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_BankAddr_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_CASn_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_CKE_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_CSn_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_RASn_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_WEn_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_DM_pin,
    DDR2_DQS,
    DDR2_DQS_N,
    DDR2_DQ,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_Clk_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_Clkn_pin,
    phy_mii_int_n,
    sys_clk_pin,
    sys_rst_pin,
    ppc440_mc_ddr2_0_mc_miaddrreadytoaccept_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_VSYNC_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_HSYNC_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_DATA_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_DE_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_CLK_N_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_CLK_P_pin,
    xps_iic_0_Scl,
    xps_iic_0_Sda,
    vga_reset_pin
  );
  input fpga_0_RS232_Uart_1_sin_pin;
  output fpga_0_RS232_Uart_1_sout_pin;
  inout [0:7] fpga_0_LEDs_8Bit_GPIO_IO_pin;
  output [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_ODT_pin;
  output [12:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_Addr_pin;
  output [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_BankAddr_pin;
  output fpga_0_DDR2_SDRAM_32Mx64_DDR_CASn_pin;
  output fpga_0_DDR2_SDRAM_32Mx64_DDR_CKE_pin;
  output fpga_0_DDR2_SDRAM_32Mx64_DDR_CSn_pin;
  output fpga_0_DDR2_SDRAM_32Mx64_DDR_RASn_pin;
  output fpga_0_DDR2_SDRAM_32Mx64_DDR_WEn_pin;
  output [7:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_DM_pin;
  inout [7:0] DDR2_DQS;
  inout [7:0] DDR2_DQS_N;
  inout [63:0] DDR2_DQ;
  output [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_Clk_pin;
  output [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_Clkn_pin;
  output phy_mii_int_n;
  input sys_clk_pin;
  input sys_rst_pin;
  output ppc440_mc_ddr2_0_mc_miaddrreadytoaccept_pin;
  output plbv46_dvi_cntlr_0_TFT_LCD_VSYNC_pin;
  output plbv46_dvi_cntlr_0_TFT_LCD_HSYNC_pin;
  output [11:0] plbv46_dvi_cntlr_0_TFT_LCD_DATA_pin;
  output plbv46_dvi_cntlr_0_TFT_LCD_DE_pin;
  output plbv46_dvi_cntlr_0_TFT_LCD_CLK_N_pin;
  output plbv46_dvi_cntlr_0_TFT_LCD_CLK_P_pin;
  inout xps_iic_0_Scl;
  inout xps_iic_0_Sda;
  output vga_reset_pin;

  system
    system_i (
      .fpga_0_RS232_Uart_1_sin_pin ( fpga_0_RS232_Uart_1_sin_pin ),
      .fpga_0_RS232_Uart_1_sout_pin ( fpga_0_RS232_Uart_1_sout_pin ),
      .fpga_0_LEDs_8Bit_GPIO_IO_pin ( fpga_0_LEDs_8Bit_GPIO_IO_pin ),
      .fpga_0_DDR2_SDRAM_32Mx64_DDR_ODT_pin ( fpga_0_DDR2_SDRAM_32Mx64_DDR_ODT_pin ),
      .fpga_0_DDR2_SDRAM_32Mx64_DDR_Addr_pin ( fpga_0_DDR2_SDRAM_32Mx64_DDR_Addr_pin ),
      .fpga_0_DDR2_SDRAM_32Mx64_DDR_BankAddr_pin ( fpga_0_DDR2_SDRAM_32Mx64_DDR_BankAddr_pin ),
      .fpga_0_DDR2_SDRAM_32Mx64_DDR_CASn_pin ( fpga_0_DDR2_SDRAM_32Mx64_DDR_CASn_pin ),
      .fpga_0_DDR2_SDRAM_32Mx64_DDR_CKE_pin ( fpga_0_DDR2_SDRAM_32Mx64_DDR_CKE_pin ),
      .fpga_0_DDR2_SDRAM_32Mx64_DDR_CSn_pin ( fpga_0_DDR2_SDRAM_32Mx64_DDR_CSn_pin ),
      .fpga_0_DDR2_SDRAM_32Mx64_DDR_RASn_pin ( fpga_0_DDR2_SDRAM_32Mx64_DDR_RASn_pin ),
      .fpga_0_DDR2_SDRAM_32Mx64_DDR_WEn_pin ( fpga_0_DDR2_SDRAM_32Mx64_DDR_WEn_pin ),
      .fpga_0_DDR2_SDRAM_32Mx64_DDR_DM_pin ( fpga_0_DDR2_SDRAM_32Mx64_DDR_DM_pin ),
      .DDR2_DQS ( DDR2_DQS ),
      .DDR2_DQS_N ( DDR2_DQS_N ),
      .DDR2_DQ ( DDR2_DQ ),
      .fpga_0_DDR2_SDRAM_32Mx64_DDR_Clk_pin ( fpga_0_DDR2_SDRAM_32Mx64_DDR_Clk_pin ),
      .fpga_0_DDR2_SDRAM_32Mx64_DDR_Clkn_pin ( fpga_0_DDR2_SDRAM_32Mx64_DDR_Clkn_pin ),
      .phy_mii_int_n ( phy_mii_int_n ),
      .sys_clk_pin ( sys_clk_pin ),
      .sys_rst_pin ( sys_rst_pin ),
      .ppc440_mc_ddr2_0_mc_miaddrreadytoaccept_pin ( ppc440_mc_ddr2_0_mc_miaddrreadytoaccept_pin ),
      .plbv46_dvi_cntlr_0_TFT_LCD_VSYNC_pin ( plbv46_dvi_cntlr_0_TFT_LCD_VSYNC_pin ),
      .plbv46_dvi_cntlr_0_TFT_LCD_HSYNC_pin ( plbv46_dvi_cntlr_0_TFT_LCD_HSYNC_pin ),
      .plbv46_dvi_cntlr_0_TFT_LCD_DATA_pin ( plbv46_dvi_cntlr_0_TFT_LCD_DATA_pin ),
      .plbv46_dvi_cntlr_0_TFT_LCD_DE_pin ( plbv46_dvi_cntlr_0_TFT_LCD_DE_pin ),
      .plbv46_dvi_cntlr_0_TFT_LCD_CLK_N_pin ( plbv46_dvi_cntlr_0_TFT_LCD_CLK_N_pin ),
      .plbv46_dvi_cntlr_0_TFT_LCD_CLK_P_pin ( plbv46_dvi_cntlr_0_TFT_LCD_CLK_P_pin ),
      .xps_iic_0_Scl ( xps_iic_0_Scl ),
      .xps_iic_0_Sda ( xps_iic_0_Sda ),
      .vga_reset_pin ( vga_reset_pin )
    );

endmodule

