#include <co.h>

long Color_Convert_Temp(co_stream output_stream, co_stream y_stream, co_stream u_stream, co_stream v_stream);


void Color_Convert(co_stream y_stream, co_stream u_stream, co_stream v_stream,co_stream output_stream)
{
	co_int32 output, output2;
	co_int16 YYY, UUU, VVV, YY1, YY2, YY3, YY4, YY5, YY6, YY7, YY8;
	co_int16 R, G, B, U1, V1, U2, V2, U3, V3, U4, V4, R2, G2, B2;
	co_uint32 iy1, iy2, iu1, iv1;
	

//	cosim_logwindow_create("HW");


    co_stream_open(output_stream, O_WRONLY, UINT_TYPE(32));
	co_stream_open(y_stream, O_RDONLY, UINT_TYPE(32));
	co_stream_open(u_stream, O_RDONLY, UINT_TYPE(32));
	co_stream_open(v_stream, O_RDONLY, UINT_TYPE(32));


	while (co_stream_read(v_stream, &iv1, sizeof(co_uint32)) == co_err_none)
	{	
#pragma CO PIPELINE
		co_stream_read(y_stream, &iy1, sizeof(co_uint32));
		co_stream_read(y_stream, &iy2, sizeof(co_uint32));
		co_stream_read(u_stream, &iu1, sizeof(co_uint32));

			
		YY1 = (iy1>>24) & 0xff; 
		YY2 = (iy1>>16) & 0xff; 
		YY3 = (iy1>>8) & 0xff; 	
		YY4 = (iy1>>0) & 0xff; 	
		YY5 = (iy2>>24) & 0xff; 
		YY6 = (iy2>>16) & 0xff; 
		YY7 = (iy2>>8) & 0xff; 	
		YY8 = (iy2>>0) & 0xff; 

		U1 = (iu1>>24) & 0xff; 
		U2 = (iu1>>16) & 0xff; 
		U3 = (iu1>>8) & 0xff; 	
		U4 = (iu1>>0) & 0xff; 

		V1 = (iv1>>24) & 0xff; 
		V2 = (iv1>>16) & 0xff; 
		V3 = (iv1>>8) & 0xff; 	
		V4 = (iv1>>0) & 0xff; 	

		/*
		output2 = ( (YY1<<24) | (YY2<<16) | (YY3<<8) | YY4) & 0xFFFFFFFF;
		co_stream_write(output_stream, &output2, sizeof(co_uint32));
		output2 = ( (U1<<24) | (U2<<16) | (U3<<8) | U4) & 0xFFFFFFFF;
		co_stream_write(output_stream, &output2, sizeof(co_uint32));
		output2 = ( (V1<<24) | (V2<<16) | (V3<<8) | V4) & 0xFFFFFFFF;
		co_stream_write(output_stream, &output2, sizeof(co_uint32));
		*/

		/*1----------------------*/

		YYY = YY1 <<8;
		VVV = V1-128;
		UUU = U1-128;
			
		R  = (YYY + (351 * VVV)) >> 8;
		G  = (YYY - (179 * VVV) - (87 * (UUU))) >> 8;
		B  = (YYY + (443 * UUU)) >> 8;
		if(R<1)R=1;
		if(G<1)G=1;
		if(B<1)B=1;
		if(R>255)R=255;
		if(G>255)G=255;
		if(B>255)B=255;
		output = (((co_uint32)R<<16) | ((co_uint32)G<<8) | (co_uint32)B) & 0x00FFFFFF;
//printf("output1\n");
		co_stream_write(output_stream, &output, sizeof(co_uint32));
		/*2-----------------------*/
		YYY = YY2 <<8;
		//V1 = V1-128;
		//U1 = U1-128;
		R  = (YYY + (351 * VVV)) >> 8;
		G  = (YYY - (179 * VVV) - (87 * (UUU))) >> 8;
		B  = (YYY + (443 * UUU)) >> 8;
		if(R<1)R=1;
		if(G<1)G=1;
		if(B<1)B=1;
		if(R>255)R=255;
		if(G>255)G=255;
		if(B>255)B=255;
		output = (((co_uint32)R<<16) | ((co_uint32)G<<8) | (co_uint32)B) & 0x00FFFFFF;
//printf("output2\n");
		co_stream_write(output_stream, &output, sizeof(co_uint32));
		/*3-----------------------*/
		YYY = YY3 <<8;
		VVV = V2-128;
		UUU = U2-128;
		R  = (YYY + (351 * VVV)) >> 8;
		G  = (YYY - (179 * VVV) - (87 * (UUU))) >> 8;
		B  = (YYY + (443 * UUU)) >> 8;
		if(R<1)R=1;
		if(G<1)G=1;
		if(B<1)B=1;
		if(R>255)R=255;
		if(G>255)G=255;
		if(B>255)B=255;
		output = (((co_uint32)R<<16) | ((co_uint32)G<<8) | (co_uint32)B) & 0x00FFFFFF;
//printf("output3\n");
		co_stream_write(output_stream, &output, sizeof(co_uint32));
		/*4-----------------------*/
		YYY = YY4 <<8;
		//V1 = V1-128;
		//U1 = U1-128;
		R  = (YYY + (351 * VVV)) >> 8;
		G  = (YYY - (179 * VVV) - (87 * (UUU))) >> 8;
		B  = (YYY + (443 * UUU)) >> 8;
		if(R<1)R=1;
		if(G<1)G=1;
		if(B<1)B=1;
		if(R>255)R=255;
		if(G>255)G=255;
		if(B>255)B=255;
		output = (((co_uint32)R<<16) | ((co_uint32)G<<8) | (co_uint32)B) & 0x00FFFFFF;
//printf("output4\n");
		co_stream_write(output_stream, &output, sizeof(co_uint32));

		/*5-----------------------*/
		YYY = YY5 <<8;
		VVV = V3-128;
		UUU = U3-128;
		R  = (YYY + (351 * VVV)) >> 8;
		G  = (YYY - (179 * VVV) - (87 * (UUU))) >> 8;
		B  = (YYY + (443 * UUU)) >> 8;
		if(R<1)R=1;
		if(G<1)G=1;
		if(B<1)B=1;
		if(R>255)R=255;
		if(G>255)G=255;
		if(B>255)B=255;
		output = (((co_uint32)R<<16) | ((co_uint32)G<<8) | (co_uint32)B) & 0x00FFFFFF;
//printf("output5\n");
		co_stream_write(output_stream, &output, sizeof(co_uint32));
		/*6-----------------------*/
		YYY = YY6 <<8;
		//V1 = V1-128;
		//U1 = U1-128;
		R  = (YYY + (351 * VVV)) >> 8;
		G  = (YYY - (179 * VVV) - (87 * (UUU))) >> 8;
		B  = (YYY + (443 * UUU)) >> 8;
		if(R<1)R=1;
		if(G<1)G=1;
		if(B<1)B=1;
		if(R>255)R=255;
		if(G>255)G=255;
		if(B>255)B=255;
		output = (((co_uint32)R<<16) | ((co_uint32)G<<8) | (co_uint32)B) & 0x00FFFFFF;
//printf("output6\n");
		co_stream_write(output_stream, &output, sizeof(co_uint32));

		/*7-----------------------*/
		YYY = YY7 <<8;
		VVV = V4-128;
		UUU = U4-128;
		R  = (YYY + (351 * VVV)) >> 8;
		G  = (YYY - (179 * VVV) - (87 * (UUU))) >> 8;
		B  = (YYY + (443 * UUU)) >> 8;
		if(R<1)R=1;
		if(G<1)G=1;
		if(B<1)B=1;
		if(R>255)R=255;
		if(G>255)G=255;
		if(B>255)B=255;
		output = (((co_uint32)R<<16) | ((co_uint32)G<<8) | (co_uint32)B) & 0x00FFFFFF;
//printf("output7\n");
		co_stream_write(output_stream, &output, sizeof(co_uint32));
		/*8-----------------------*/
		YYY = YY8 <<8;
		//V1 = V1-128;
		//U1 = U1-128;
		R  = (YYY + (351 * VVV)) >> 8;
		G  = (YYY - (179 * VVV) - (87 * (UUU))) >> 8;
		B  = (YYY + (443 * UUU)) >> 8;
		if(R<1)R=1;
		if(G<1)G=1;
		if(B<1)B=1;
		if(R>255)R=255;
		if(G>255)G=255;
		if(B>255)B=255;
		output = (((co_uint32)R<<16) | ((co_uint32)G<<8) | (co_uint32)B) & 0x00FFFFFF;
//printf("output8\n");
		co_stream_write(output_stream, &output, sizeof(co_uint32));
	
	}

    co_stream_close(y_stream);
	co_stream_close(u_stream);
	co_stream_close(v_stream);
	co_stream_close(output_stream);

}

//Configuration function of CoDeveloper project
//Every CoDeveloper project must contain a single configuration function, which declares processes, 
//streams and connectivity in the system
void config_conv(void *arg)
{
    co_process sw_proc, hw_proc;	//system processes
    co_stream y_stream, u_stream, v_stream, output_stream;	//system streams

//	cosim_logwindow_init();

	//Declaration of streams
	//Usage : (co_stream)stream_name = co_stream_create("stream_name_for_sims", size_of_stream_element, no_of_stream_elements);
    output_stream = co_stream_create("output_stream", UINT_TYPE(32), 16);
    y_stream = co_stream_create("y_stream", UINT_TYPE(32), 16);
	u_stream = co_stream_create("u_stream", UINT_TYPE(32), 8);
	v_stream = co_stream_create("v_stream", UINT_TYPE(32), 8);

	//Declaration of processes
	//Usage : (co_process)process_names = co_process_create("process_name_for_sims", (co_function)function_name, number_of_arguments, arg1, arg2,....); 
    sw_proc = co_process_create("sw_proc", (co_function)Color_Convert_Temp, 4, output_stream, y_stream, u_stream, v_stream);
	hw_proc = co_process_create("hw_proc", (co_function)Color_Convert, 4, y_stream, u_stream, v_stream, output_stream);
    //sw_proc = co_process_create("sw_proc", (co_function)Color_Convert_Temp, 2, output_stream, y_stream);
	//hw_proc = co_process_create("hw_proc", (co_function)Color_Convert, 2, y_stream, output_stream);

	//mand_hw_proc to be moved to hardware
	//Usage: co_process_config(process, attribute_to_change, attribute_value);
	//currently only attribute_to_change = co_loc, and attribute_value = PE0 is supported
    co_process_config(hw_proc, co_loc, "PE0");

}

//Every CoDeveloper project must contain one co_initialize()
//which is called from main()
co_architecture co_initialize()     
{
	//Associate the above configuration function with a specific architecture.
	//The target architecture for compilation however is set in the project > options menu.
    return(co_architecture_create("colorConv", "generic", config_conv, NULL));
}
