//*****************************************************************************
// Copyright  2006, Xilinx, Inc. 
// This design is confidential and proprietary of Xilinx, Inc. All Rights Reserved.
//*****************************************************************************
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /   Vendor: Xilinx 
// \   \   \/    Version: 1.0
//  \   \        Filename: 
//  /   /        Date Last Modified: 
// /___/   /\    Date Created: 10-sep-06 
// \   \  /  \ 
//  \___\/\___\ 
// 
// Device: 
// Purpose:   
// Reference: 
//----------------------------------------------------------------------------
 
//   
//*****************************************************************************
//
//  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are
//              provided to you "as is." Xilinx and its licensors make and you
//              receive no warranties or conditions, express, implied,
//              statutory or otherwise, and Xilinx specifically disclaims any
//              implied warranties of merchantability, no infringement, or
//              fitness for a particular purpose. Xilinx does not warrant that
//              the functions contained in these designs will meet your
//              requirements, or that the operation of these designs will be
//              uninterrupted or error free, or that defects in the Designs
//              will be corrected. Furthermore, Xilinx does not warrant or
//              make any representations regarding use or the results of the
//              use of the designs in terms of correctness, accuracy,
//              reliability, or otherwise.
//
//              LIMITATION OF LIABILITY. In no event will Xilinx or its
//              licensors be liable for any loss of data, lost profits, cost
//              or procurement of substitute goods or services, or for any
//              special, incidental, consequential, or indirect damages
//              arising from the use or operation of the designs or
//              accompanying documentation, however caused and on any theory
//              of liability. This limitation will apply even if Xilinx
//              has been advised of the possibility of such damage. This
//              limitation shall apply notwithstanding the failure of the
//              essential purpose of any limited remedies herein.
//
//*****************************************************************************/
//----------------------------------------------------------------------------
// Filename:     bootload_graphics.h
// 
// Description:   Basic functions to plot on TFT display 
//
// Design Notes:
//   
//-----------------------------------------------------------------------------
// Xilinx APD
// History:
// 
//
//-----------------------------------------------------------------------------

#ifndef BOOTLOAD_BASICGRAPHICS_H
	#define BOOTLOAD_BASICGRAPHICS_H
#endif
#include "xtft.h"
#include "xtft_l.h"

void XTft_WriteString(XTft *InstancePtr, unsigned char *val);
int XTft_DrawLine(XTft *InstancePtr, int x1, int y1, int x2, int y2, unsigned int col);
int XTft_DrawEmptyBox(XTft *InstancePtr, int x1, int y1, int x2, int y2, unsigned int col, int thickness);
int XTft_DrawSolidBox(XTft *InstancePtr, int x1, int y1, int x2, int y2, unsigned int col);

// Alvin's additions
//void InitGraphics(XTft *TftPtr, XTouchscreen *TouchscreenPtr, unsigned int fgCol, unsigned int bgCol);
void XTft_WriteColor(XTft *InstancePtr, unsigned char c, unsigned int fgcol, unsigned int bgCol);
void XTft_WriteColorString(XTft *InstancePtr, unsigned char *val, unsigned int fgCol, unsigned int bgCol);



