#ifndef APU_IF_H
#define APU_IF_H

/* APU assignments */
#if !defined(IMPULSE_FIRST_APU)

#define p_Producer_istream_data() "0"
#define p_Producer_istream_status() "2"
#define p_Consumer_ostream_data() "4"
#define p_Consumer_ostream_status() "6"
#define p_sw_proc_output_stream_data() "8"
#define p_sw_proc_output_stream_status() "10"
#define p_sw_proc_y_stream_data() "12"
#define p_sw_proc_y_stream_status() "14"
#define p_sw_proc_u_stream_data() "16"
#define p_sw_proc_u_stream_status() "18"
#define p_sw_proc_v_stream_data() "20"
#define p_sw_proc_v_stream_status() "22"
#define p_config_sys_data() "24"
#else

#if IMPULSE_FIRST_APU == 0

#define p_Producer_istream_data() "0"
#define p_Producer_istream_status() "2"
#define p_Consumer_ostream_data() "4"
#define p_Consumer_ostream_status() "6"
#define p_sw_proc_output_stream_data() "8"
#define p_sw_proc_output_stream_status() "10"
#define p_sw_proc_y_stream_data() "12"
#define p_sw_proc_y_stream_status() "14"
#define p_sw_proc_u_stream_data() "16"
#define p_sw_proc_u_stream_status() "18"
#define p_sw_proc_v_stream_data() "20"
#define p_sw_proc_v_stream_status() "22"
#define p_config_sys_data() "24"
#endif

#if IMPULSE_FIRST_APU == 1

#define p_Producer_istream_data() "4"
#define p_Producer_istream_status() "6"
#define p_Consumer_ostream_data() "8"
#define p_Consumer_ostream_status() "10"
#define p_sw_proc_output_stream_data() "12"
#define p_sw_proc_output_stream_status() "14"
#define p_sw_proc_y_stream_data() "16"
#define p_sw_proc_y_stream_status() "18"
#define p_sw_proc_u_stream_data() "20"
#define p_sw_proc_u_stream_status() "22"
#define p_sw_proc_v_stream_data() "24"
#define p_sw_proc_v_stream_status() "26"
#define p_config_sys_data() "28"
#endif

#if IMPULSE_FIRST_APU == 2

#define p_Producer_istream_data() "8"
#define p_Producer_istream_status() "10"
#define p_Consumer_ostream_data() "12"
#define p_Consumer_ostream_status() "14"
#define p_sw_proc_output_stream_data() "16"
#define p_sw_proc_output_stream_status() "18"
#define p_sw_proc_y_stream_data() "20"
#define p_sw_proc_y_stream_status() "22"
#define p_sw_proc_u_stream_data() "24"
#define p_sw_proc_u_stream_status() "26"
#define p_sw_proc_v_stream_data() "28"
#define p_sw_proc_v_stream_status() "30"
#define p_config_sys_data() "32"
#endif

#if IMPULSE_FIRST_APU == 3

#define p_Producer_istream_data() "12"
#define p_Producer_istream_status() "14"
#define p_Consumer_ostream_data() "16"
#define p_Consumer_ostream_status() "18"
#define p_sw_proc_output_stream_data() "20"
#define p_sw_proc_output_stream_status() "22"
#define p_sw_proc_y_stream_data() "24"
#define p_sw_proc_y_stream_status() "26"
#define p_sw_proc_u_stream_data() "28"
#define p_sw_proc_u_stream_status() "30"
#define p_sw_proc_v_stream_data() "32"
#define p_sw_proc_v_stream_status() "34"
#define p_config_sys_data() "36"
#endif

#if IMPULSE_FIRST_APU == 4

#define p_Producer_istream_data() "16"
#define p_Producer_istream_status() "18"
#define p_Consumer_ostream_data() "20"
#define p_Consumer_ostream_status() "22"
#define p_sw_proc_output_stream_data() "24"
#define p_sw_proc_output_stream_status() "26"
#define p_sw_proc_y_stream_data() "28"
#define p_sw_proc_y_stream_status() "30"
#define p_sw_proc_u_stream_data() "32"
#define p_sw_proc_u_stream_status() "34"
#define p_sw_proc_v_stream_data() "36"
#define p_sw_proc_v_stream_status() "38"
#define p_config_sys_data() "40"
#endif

#if IMPULSE_FIRST_APU == 5

#define p_Producer_istream_data() "20"
#define p_Producer_istream_status() "22"
#define p_Consumer_ostream_data() "24"
#define p_Consumer_ostream_status() "26"
#define p_sw_proc_output_stream_data() "28"
#define p_sw_proc_output_stream_status() "30"
#define p_sw_proc_y_stream_data() "32"
#define p_sw_proc_y_stream_status() "34"
#define p_sw_proc_u_stream_data() "36"
#define p_sw_proc_u_stream_status() "38"
#define p_sw_proc_v_stream_data() "40"
#define p_sw_proc_v_stream_status() "42"
#define p_config_sys_data() "44"
#endif

#if IMPULSE_FIRST_APU == 6

#define p_Producer_istream_data() "24"
#define p_Producer_istream_status() "26"
#define p_Consumer_ostream_data() "28"
#define p_Consumer_ostream_status() "30"
#define p_sw_proc_output_stream_data() "32"
#define p_sw_proc_output_stream_status() "34"
#define p_sw_proc_y_stream_data() "36"
#define p_sw_proc_y_stream_status() "38"
#define p_sw_proc_u_stream_data() "40"
#define p_sw_proc_u_stream_status() "42"
#define p_sw_proc_v_stream_data() "44"
#define p_sw_proc_v_stream_status() "46"
#define p_config_sys_data() "48"
#endif

#if IMPULSE_FIRST_APU == 7

#define p_Producer_istream_data() "28"
#define p_Producer_istream_status() "30"
#define p_Consumer_ostream_data() "32"
#define p_Consumer_ostream_status() "34"
#define p_sw_proc_output_stream_data() "36"
#define p_sw_proc_output_stream_status() "38"
#define p_sw_proc_y_stream_data() "40"
#define p_sw_proc_y_stream_status() "42"
#define p_sw_proc_u_stream_data() "44"
#define p_sw_proc_u_stream_status() "46"
#define p_sw_proc_v_stream_data() "48"
#define p_sw_proc_v_stream_status() "50"
#define p_config_sys_data() "52"
#endif

#endif

#define GENERATE_STREAM_WRITE0 16
#define GENERATE_STREAM_CLOSE2
#define GENERATE_STREAM_INSTR0 "lqfcmx"
#define GENERATE_STREAM_READ4 16
#define GENERATE_STREAM_INSTR4 "stqfcmx"
#define GENERATE_STREAM_READ8 16
#define GENERATE_STREAM_INSTR8 "stqfcmx"
#define GENERATE_STREAM_WRITE12 16
#define GENERATE_STREAM_CLOSE14
#define GENERATE_STREAM_INSTR12 "lqfcmx"
#define GENERATE_STREAM_WRITE16 16
#define GENERATE_STREAM_CLOSE18
#define GENERATE_STREAM_INSTR16 "lqfcmx"
#define GENERATE_STREAM_WRITE20 16
#define GENERATE_STREAM_CLOSE22
#define GENERATE_STREAM_INSTR20 "lqfcmx"

#endif
