#include <stdio.h>
#include <co.h>
 
//co_initialize() is defined in mand_accel_hw.c
extern co_architecture co_initialize(void *);

//SW
extern void Color_Convert_Temp(co_stream output_stream, co_stream y_stream, co_stream u_stream, co_stream v_stream)
{
	unsigned char y[240] = {5   ,6 , 7, 8, 9, 10, 11, 12, 45 , 128, 77, 88};
	unsigned char u[120] = {128 ,130, 131, 128, 128, 127, 33 , 120, 128, 250, 101, 102};
	unsigned char v[120] = {128 ,128, 127, 128, 128 , 129, 220, 180, 128, 128, 101, 102};
	unsigned char r[200];
	unsigned char g[200];
	unsigned char b[200];
	//unsigned char x[200];

	int i, j, k, idx, idxY;
	co_uint32 err;
	co_int32 pixelValue;
	
	co_stream_open(output_stream, O_RDONLY, UINT_TYPE(32));
	co_stream_open(y_stream, O_WRONLY, UINT_TYPE(32));
	co_stream_open(u_stream, O_WRONLY, UINT_TYPE(32));
	co_stream_open(v_stream, O_WRONLY, UINT_TYPE(32));
	
	for(j=0;j<5;j++)
	{
	  for(i=0;i<32; i=i+8)
		{
			idxY = 32*j+i;
			printf("YY:%d\n", idxY);
			idx = 5/2*(j>>1)+(i>>1);

			co_stream_write(y_stream, &y[idxY], sizeof(co_uint32));
			co_stream_write(y_stream, &y[idxY+4], sizeof(co_uint32));
			//co_stream_write(y_stream, &y[idxY+8], sizeof(co_uint32));
			//co_stream_write(y_stream, &y[idxY+12], sizeof(co_uint32));
			
			co_stream_write(u_stream, &u[idx], sizeof(co_uint32));
			//co_stream_write(u_stream, &u[idx+4], sizeof(co_uint32));
			
			co_stream_write(v_stream, &v[idx], sizeof(co_uint32));
			//co_stream_write(v_stream, &v[idx+4], sizeof(co_uint32));
			
			co_stream_read(output_stream, &pixelValue, sizeof(co_uint32));
			co_stream_read(output_stream, &pixelValue, sizeof(co_uint32));
			co_stream_read(output_stream, &pixelValue, sizeof(co_uint32));
			co_stream_read(output_stream, &pixelValue, sizeof(co_uint32));
			co_stream_read(output_stream, &pixelValue, sizeof(co_uint32));
			co_stream_read(output_stream, &pixelValue, sizeof(co_uint32));
			co_stream_read(output_stream, &pixelValue, sizeof(co_uint32));
			co_stream_read(output_stream, &pixelValue, sizeof(co_uint32));
		}
	}
	co_stream_close(y_stream);
	co_stream_close(u_stream);
	co_stream_close(v_stream);
	
	co_stream_close(output_stream);
	

	for(j=0 ; j<16 ; ++j)
	{
		printf("SeeW - rgb[%d]=(%d %d %d)\n", j, r[j], g[j], b[j]);
	}
	
}	

main()
{
	co_architecture my_arch; 			//CoDeveloper system
	printf("c u monday\n\n\n\n\n");
	my_arch = co_initialize(NULL);
	//Run HW version
	co_execute(my_arch);

	printf("End\n");
}





